FontLineShapeRenderer
Date: 2019-10-22

org.jmol.render

## Class FontLineShapeRenderer

- java.lang.Object
- - org.jmol.render.ShapeRenderer
  - - org.jmol.render.FontLineShapeRenderer

- Direct Known Subclasses:
    CageRenderer, LabelsRenderer, SticksRenderer

      public abstract class FontLineShapeRenderer
      extends ShapeRenderer

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `asLineOnly`
    `protected short` | `colixA`
    `protected short` | `colixB`
    `protected int[]` | `dashDots`
    `protected static int[]` | `dashes`
    `protected boolean` | `dotsOrDashes`
    `protected boolean` | `draw000`
    `protected byte` | `endcap`
    `protected Font` | `font3d`
    `protected static int[]` | `fourdots`
    `protected static int[]` | `hDashes`
    `protected float` | `imageFontScaling`
    `protected static int[]` | `ndots`
    `protected javajs.util.P3` | `pointT`
    `protected javajs.util.P3` | `pointT2`
    `protected javajs.util.P3` | `pointT3`
    `protected javajs.util.P3` | `pt0`
    `protected javajs.util.P3i` | `pt0i`
    `protected javajs.util.P3` | `pt1`
    `protected javajs.util.P3i` | `pt2i`
    `protected javajs.util.P3i` | `s1`
    `protected javajs.util.P3i` | `s2`
    `protected static int[]` | `sixdots`
    `protected javajs.util.P3` | `tickA`
    `protected javajs.util.P3` | `tickAs`
    `protected javajs.util.P3` | `tickB`
    `protected javajs.util.P3` | `tickBs`
    `protected TickInfo` | `tickInfo`
    `protected static int[]` | `twodots`
    `protected javajs.util.V3` | `vectorT`
    `protected javajs.util.V3` | `vectorT2`
    `protected javajs.util.V3` | `vectorT3`
    `protected int` | `width`

    - ### Fields inherited from class org.jmol.render.ShapeRenderer

      `colix, exportType, g3d, isExport, mad, ms, myVisibilityFlag, shape, shapeID, tm, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FontLineShapeRenderer()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `checkTickTemps()`
    `protected void` | `drawDashed(int xA, int yA, int zA, int xB, int yB, int zB, int[] array)`
    `protected int` | `drawLine(int x1, int y1, int z1, int x2, int y2, int z2, int diameter)`
    `protected int` | `drawLine2(int x1, int y1, int z1, int x2, int y2, int z2, int diameter)`
    `protected void` | `drawString(int x, int y, int z, int radius, boolean rightJustify, boolean centerX, boolean centerY, int yRef, java.lang.String sVal)`
    `protected void` | `drawTicks(int diameter, boolean withLabels)`
    `private void` | `drawTicks2(float dx, int length, int diameter, java.lang.String[] formats)`
    `protected void` | `fillCylinder(short colixA, short colixB, byte endcaps, int diameter, int xA, int yA, int zA, int xB, int yB, int zB)`
    `protected int` | `getDiameter(int z, int mad10OrPixels)`
    `protected void` | `renderLine(javajs.util.P3 p0, javajs.util.P3 p1, int diameter, boolean drawTicks)`

    - ### Methods inherited from class org.jmol.render.ShapeRenderer

      `initRenderer, isVisibleForMe, render, renderShape, setup, setViewerG3dShapeID`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### imageFontScaling

          protected float imageFontScaling

    - #### tickA

          protected javajs.util.P3 tickA

    - #### tickB

          protected javajs.util.P3 tickB

    - #### tickAs

          protected javajs.util.P3 tickAs

    - #### tickBs

          protected javajs.util.P3 tickBs

    - #### font3d

          protected Font font3d

    - #### pt0i

          protected final javajs.util.P3i pt0i

    - #### pt2i

          protected final javajs.util.P3i pt2i

    - #### s1

          protected final javajs.util.P3i s1

    - #### s2

          protected final javajs.util.P3i s2

    - #### pointT

          protected final javajs.util.P3 pointT

    - #### pointT2

          protected final javajs.util.P3 pointT2

    - #### pointT3

          protected final javajs.util.P3 pointT3

    - #### vectorT

          protected final javajs.util.V3 vectorT

    - #### vectorT2

          protected final javajs.util.V3 vectorT2

    - #### vectorT3

          protected final javajs.util.V3 vectorT3

    - #### tickInfo

          protected TickInfo tickInfo

    - #### draw000

          protected boolean draw000

    - #### width

          protected int width

    - #### endcap

          protected byte endcap

    - #### pt0

          protected javajs.util.P3 pt0

    - #### pt1

          protected javajs.util.P3 pt1

    - #### dashes

          protected static final int[] dashes

    - #### hDashes

          protected static final int[] hDashes

    - #### ndots

          protected static final int[] ndots

    - #### sixdots

          protected static final int[] sixdots

    - #### fourdots

          protected static final int[] fourdots

    - #### twodots

          protected static final int[] twodots

    - #### colixA

          protected short colixA

    - #### colixB

          protected short colixB

    - #### dotsOrDashes

          protected boolean dotsOrDashes

    - #### dashDots

          protected int[] dashDots

    - #### asLineOnly

          protected boolean asLineOnly

  - ### Constructor Detail

    - #### FontLineShapeRenderer

          public FontLineShapeRenderer()

  - ### Method Detail

    - #### getDiameter

          protected int getDiameter(int z,
                                    int mad10OrPixels)

    - #### renderLine

          protected void renderLine(javajs.util.P3 p0,
                                    javajs.util.P3 p1,
                                    int diameter,
                                    boolean drawTicks)

    - #### checkTickTemps

          protected void checkTickTemps()

    - #### drawTicks

          protected void drawTicks(int diameter,
                                   boolean withLabels)

    - #### drawTicks2

          private void drawTicks2(float dx,
                                  int length,
                                  int diameter,
                                  java.lang.String[] formats)

    - #### drawLine

          protected int drawLine(int x1,
                                 int y1,
                                 int z1,
                                 int x2,
                                 int y2,
                                 int z2,
                                 int diameter)

    - #### drawLine2

          protected int drawLine2(int x1,
                                  int y1,
                                  int z1,
                                  int x2,
                                  int y2,
                                  int z2,
                                  int diameter)

    - #### drawString

          protected void drawString(int x,
                                    int y,
                                    int z,
                                    int radius,
                                    boolean rightJustify,
                                    boolean centerX,
                                    boolean centerY,
                                    int yRef,
                                    java.lang.String sVal)

    - #### drawDashed

          protected void drawDashed(int xA,
                                    int yA,
                                    int zA,
                                    int xB,
                                    int yB,
                                    int zB,
                                    int[] array)

    - #### fillCylinder

          protected void fillCylinder(short colixA,
                                      short colixB,
                                      byte endcaps,
                                      int diameter,
                                      int xA,
                                      int yA,
                                      int zA,
                                      int xB,
                                      int yB,
                                      int zB)